using System;
using System.Drawing;
using System.Collections;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using Syncfusion.Drawing;
using Syncfusion.Windows.Forms.Grid;

namespace Forum
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.GridControl gridControl1;
		private System.Windows.Forms.Button button1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			dt = new DataTable("Table");
			dt.Columns.Add("Product",typeof(System.String));
			dt.Columns.Add("Product_ID",typeof(System.Int32));
			//dt.PrimaryKey = new DataColumn[] {dt.Columns["Product_ID"]};
			dt.Columns.Add("QtyPerUnit",typeof(System.String));
			dt.Columns.Add("UnitPrice",typeof(System.Double));

			dt.Rows.Add(new Object[] { "Cofee",1,"1 kg",Double.NaN});
			dt.Rows.Add(new Object[] { "Tea",2,"1 kg",120.00});
			dt.Rows.Add(new Object[] { "Milk Powder",3,"1 kg",260.00});
			dt.Rows.Add(new Object[] { "Biscuts",4,"1 Packet",20.00});
			dt.Rows.Add(new Object[] { "Pepsi",5,"1 Lit",60.00});
			dt.Rows.Add(new Object[] { "CoKe",6,"1 Lit",55.00});

			dv = new DataView(dt);

			this.gridControl1.QueryCellInfo += new Syncfusion.Windows.Forms.Grid.GridQueryCellInfoEventHandler(gridControl1_QueryCellInfo);
			this.gridControl1.SaveCellInfo += new Syncfusion.Windows.Forms.Grid.GridSaveCellInfoEventHandler(gridControl1_SaveCellInfo);
			this.gridControl1.QueryColCount += new Syncfusion.Windows.Forms.Grid.GridRowColCountEventHandler(gridControl1_QueryColCount);
			this.gridControl1.QueryRowCount += new Syncfusion.Windows.Forms.Grid.GridRowColCountEventHandler(gridControl1_QueryRowCount);
			this.gridControl1.ResetVolatileData();

			this.gridControl1.Model.ColWidths.ResizeToFit(GridRangeInfo.Table());
		}
		DataView dv;

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridControl1 = new Syncfusion.Windows.Forms.Grid.GridControl();
			this.button1 = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.gridControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridControl1
			// 
			this.gridControl1.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.gridControl1.Location = new System.Drawing.Point(16, 16);
			this.gridControl1.Name = "gridControl1";
			this.gridControl1.Size = new System.Drawing.Size(304, 208);
			this.gridControl1.SmartSizeBox = false;
			this.gridControl1.TabIndex = 0;
			this.gridControl1.Text = "gridControl1";
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(96, 240);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(128, 23);
			this.button1.TabIndex = 1;
			this.button1.Text = "Delete";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(336, 278);
			this.Controls.Add(this.button1);
			this.Controls.Add(this.gridControl1);
			this.Name = "Form1";
			this.Text = "Form1";
			((System.ComponentModel.ISupportInitialize)(this.gridControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		DataTable dt;

		private void gridControl1_QueryCellInfo(object sender, Syncfusion.Windows.Forms.Grid.GridQueryCellInfoEventArgs e)
		{
			if(e.ColIndex > 0 && e.RowIndex > 0)
			{
				e.Style.CellValue = dv[e.RowIndex-1][e.ColIndex-1];
			}
			else if(e.ColIndex > 0 && e.RowIndex == 0)
			{
				e.Style.Text = this.dt.Columns[e.ColIndex-1].ColumnName;
			}
			e.Handled = true;

		}
		int nCols;
		int nRows;
		private DataTable GetTable()
		{
			nCols = 50;
			nRows = 200;
			DataTable dt = new DataTable("table");
			for(int i = 0; i < nCols; i++)
				dt.Columns.Add(new DataColumn(string.Format("Col{0}", i)));

			for(int i = 0; i < nRows; ++i)
			{
				DataRow dr = dt.NewRow();
				for(int j = 0; j < nCols; j++)
				{
					dr[j] = string.Format("row{0} col{1}", i, j);
					
				}
				dt.Rows.Add(dr);
			}
			return dt;
		}

		private void gridControl1_QueryColCount(object sender, Syncfusion.Windows.Forms.Grid.GridRowColCountEventArgs e)
		{
			e.Count = dt.Columns.Count;
			e.Handled = true;
		}

		private void gridControl1_QueryRowCount(object sender, Syncfusion.Windows.Forms.Grid.GridRowColCountEventArgs e)
		{
			e.Count = dt.Rows.Count;
			e.Handled = true;
		}
		
		private void gridControl1_SaveCellInfo(object sender, Syncfusion.Windows.Forms.Grid.GridSaveCellInfoEventArgs e)
		{
			if(e.ColIndex > 0 && e.RowIndex > 0)
				dv[e.RowIndex-1][e.ColIndex-1] = e.Style.CellValue.ToString();
			e.Handled = true;
		}

		int i = 7;
		private void button1_Click(object sender, System.EventArgs e)
		{
			DataRow dr = dt.NewRow();
			dr[1] = i++;
			dt.Rows.Add(dr);
			this.gridControl1.ResetVolatileData();
            this.gridControl1.UpdateScrollBars();
            this.gridControl1.InvalidateRange(GridRangeInfo.Row(this.gridControl1.RowCount));
			this.gridControl1.ScrollCellInView(GridRangeInfo.Row(this.gridControl1.RowCount));
		}
	}
}
